/*
 * 小程序版本
 */

using System;
using System.Web;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Http;
using Microsoft.Extensions.Logging;
using Microsoft.Extensions.Options;
using MySystem.Models;
using Library;
using LitJson;
using MySystemLib;

namespace MySystem.Areas.Admin.Controllers
{
    [Area("Admin")]
    [Route("Admin/[controller]/[action]")]
    public class ProjectVersionController : BaseController
    {
        public ProjectVersionController(IHttpContextAccessor accessor, ILogger<BaseController> logger, IOptions<Setting> setting) : base(accessor, logger, setting)
        {
        }

        #region 小程序版本列表

        /// <summary>
        /// 根据条件查询小程序版本列表
        /// </summary>
        /// <returns></returns>
        public IActionResult Index(ProjectVersion data, string right)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;
            
            
            return View();
        }

        #endregion

        #region 根据条件查询小程序版本列表

        /// <summary>
        /// 小程序版本列表
        /// </summary>
        /// <returns></returns>
        public JsonResult IndexData(ProjectVersion data, string ProjectIdSelect, string UserIdRealName, string UserIdMobile, string DeveloperIdNickName, string DeveloperIdRealName, string DeveloperIdMobile, int page = 1, int limit = 30)
        {
            
            Dictionary<string, string> Fields = new Dictionary<string, string>();
            
            Fields.Add("CreateDate", "3"); //时间


            string condition = " and Status>-1";
            //小程序项目
if (!string.IsNullOrEmpty(ProjectIdSelect))
{
condition += " and ProjectId=" + ProjectIdSelect;
}
//所属用户真实姓名
if (!string.IsNullOrEmpty(UserIdRealName))
{
condition += " and UserId in (select UserId from UsersForRealName where RealName='" + UserIdRealName + "')";
}
//所属用户手机号
if (!string.IsNullOrEmpty(UserIdMobile))
{
condition += " and UserId in (select UserId from UsersForMobile where Mobile='" + UserIdMobile + "')";
}
//开发者昵称
if (!string.IsNullOrEmpty(DeveloperIdNickName))
{
condition += " and DeveloperId in (select DeveloperId from DevelopersForNickName where NickName='" + DeveloperIdNickName + "')";
}
//开发者真实姓名
if (!string.IsNullOrEmpty(DeveloperIdRealName))
{
condition += " and DeveloperId in (select DeveloperId from DevelopersForRealName where RealName='" + DeveloperIdRealName + "')";
}
//开发者手机号
if (!string.IsNullOrEmpty(DeveloperIdMobile))
{
condition += " and DeveloperId in (select DeveloperId from DevelopersForMobile where Mobile='" + DeveloperIdMobile + "')";
}


            Dictionary<string, object> obj = new AdminContent(_accessor.HttpContext, SystemPublicFuction.dbtables).IndexData("ProjectVersion", Fields, "Id desc", "0", page, limit, condition);
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;
            foreach (Dictionary<string, object> dic in diclist)
            {
                //小程序项目
// dic["ProjectId"] = RelationClass.GetProjectsInfo(int.Parse(dic["ProjectId"].ToString()));
//所属用户
int UserId = int.Parse(function.CheckInt(dic["UserId"].ToString()));
Users userid_Users = db.Users.FirstOrDefault(m => m.Id == UserId) ?? new Users();
dic["UserIdRealName"] = userid_Users.RealName;
dic["UserIdMobile"] = userid_Users.Mobile;
dic.Remove("UserId");
//开发者
int DeveloperId = int.Parse(function.CheckInt(dic["DeveloperId"].ToString()));
Developers developerid_Developers = db.Developers.FirstOrDefault(m => m.Id == DeveloperId) ?? new Developers();
dic["DeveloperIdNickName"] = developerid_Developers.NickName;
dic["DeveloperIdRealName"] = developerid_Developers.RealName;
dic["DeveloperIdMobile"] = developerid_Developers.Mobile;
dic.Remove("DeveloperId");

            }
            return Json(obj);
        }

        #endregion

        #region 增加小程序版本

        /// <summary>
        /// 增加或修改小程序版本信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Add(string right)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;
            

            return View();
        }

        #endregion

        #region 增加小程序版本

        /// <summary>
        /// 增加或修改小程序版本信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Add(ProjectVersion data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();
            
            Fields.Add("ProjectId", data.ProjectId); //小程序项目
Fields.Add("UserId", data.UserId); //所属用户
Fields.Add("DeveloperId", data.DeveloperId); //开发者
Fields.Add("VerNum", data.VerNum); //版本号
Fields.Add("UpdateNote", data.UpdateNote); //更新说明
Fields.Add("ReturnNote", data.ReturnNote); //反馈意见
Fields.Add("FilePath", data.FilePath); //模板文件路径

            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            int Id = new AdminContent(_accessor.HttpContext, SystemPublicFuction.dbtables).Add("ProjectVersion", Fields, 0);
            AddSysLog(data.Id.ToString(), "ProjectVersion", "add");
            db.SaveChanges();
            
            return "success";
        }

        #endregion

        #region 修改小程序版本

        /// <summary>
        /// 增加或修改小程序版本信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Edit(string right, int Id = 0)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;
            

            ProjectVersion editData = db.ProjectVersion.FirstOrDefault(m => m.Id == Id) ?? new ProjectVersion();
            ViewBag.data = editData;
            return View();
        }

        #endregion

        #region 修改小程序版本

        /// <summary>
        /// 增加或修改小程序版本信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Edit(ProjectVersion data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();
            
            Fields.Add("ProjectId", data.ProjectId); //小程序项目
Fields.Add("UserId", data.UserId); //所属用户
Fields.Add("DeveloperId", data.DeveloperId); //开发者
Fields.Add("VerNum", data.VerNum); //版本号
Fields.Add("UpdateNote", data.UpdateNote); //更新说明
Fields.Add("ReturnNote", data.ReturnNote); //反馈意见
Fields.Add("FilePath", data.FilePath); //模板文件路径

            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            new AdminContent(_accessor.HttpContext, SystemPublicFuction.dbtables).Edit("ProjectVersion", Fields, data.Id);
            AddSysLog(data.Id.ToString(),"ProjectVersion","update");
            db.SaveChanges();
            
            return "success";
        }

        #endregion

        #region 删除小程序版本信息

        /// <summary>
        /// 删除小程序版本信息
        /// </summary>
        /// <returns></returns>
        public string Delete(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id,"ProjectVersion","del");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", -1);
                new AdminContent(_accessor.HttpContext, SystemPublicFuction.dbtables).Edit("ProjectVersion", Fields, id);
            }
            db.SaveChanges();
            
            return "success";
        }

        #endregion

        #region 开启

        /// <summary>
        /// 开启
        /// </summary>
        /// <returns></returns>
        public string Open(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id,"ProjectVersion","open");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 1);
                new AdminContent(_accessor.HttpContext, SystemPublicFuction.dbtables).Edit("ProjectVersion", Fields, id);
            }
            db.SaveChanges();
            return "success";
        }

        #endregion

        #region 关闭

        /// <summary>
        /// 关闭
        /// </summary>
        /// <returns></returns>
        public string Close(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id,"ProjectVersion","close");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 0);
                new AdminContent(_accessor.HttpContext, SystemPublicFuction.dbtables).Edit("ProjectVersion", Fields, id);
            }
            db.SaveChanges();
            return "success";
        }

        #endregion

        #region 排序
        /// <summary>
        /// 排序
        /// </summary>
        /// <param name="Id"></param>
        public string Sort(int Id, int Sort)
        {
            new AdminContent(_accessor.HttpContext, SystemPublicFuction.dbtables).Sort("ProjectVersion", Sort, Id);
            
            AddSysLog(Id.ToString(), "ProjectVersion", "sort");
            return "success";
        }
        #endregion

        #region 导入数据
        /// <summary>
        /// 导入数据
        /// </summary>
        /// <param name="ExcelData"></param>
        public string Import(string ExcelData)
        {
            ExcelData = HttpUtility.UrlDecode(ExcelData);
            JsonData list = JsonMapper.ToObject(ExcelData);
            for (int i = 1; i < list.Count;i++ )
            {
                JsonData dr = list[i];
                
                db.ProjectVersion.Add(new ProjectVersion()
                {
                    CreateDate = DateTime.Now,
                    UpdateDate = DateTime.Now,
                    
                });
                db.SaveChanges();
            }
            AddSysLog("0", "ProjectVersion", "Import");
            return "success";
        }
        #endregion

        #region 导出Excel

        /// <summary>
        /// 导出Excel
        /// </summary>
        /// <returns></returns>
        public JsonResult ExportExcel(ProjectVersion data, string ProjectIdSelect, string UserIdRealName, string UserIdMobile, string DeveloperIdNickName, string DeveloperIdRealName, string DeveloperIdMobile)
        {
            Dictionary<string, string> Fields = new Dictionary<string, string>();
            Fields.Add("CreateDate", "3"); //时间


            string condition = " and Status>-1";
            //小程序项目
if (!string.IsNullOrEmpty(ProjectIdSelect))
{
condition += " and ProjectId=" + ProjectIdSelect;
}
//所属用户真实姓名
if (!string.IsNullOrEmpty(UserIdRealName))
{
condition += " and UserId in (select UserId from UsersForRealName where RealName='" + UserIdRealName + "')";
}
//所属用户手机号
if (!string.IsNullOrEmpty(UserIdMobile))
{
condition += " and UserId in (select UserId from UsersForMobile where Mobile='" + UserIdMobile + "')";
}
//开发者昵称
if (!string.IsNullOrEmpty(DeveloperIdNickName))
{
condition += " and DeveloperId in (select DeveloperId from DevelopersForNickName where NickName='" + DeveloperIdNickName + "')";
}
//开发者真实姓名
if (!string.IsNullOrEmpty(DeveloperIdRealName))
{
condition += " and DeveloperId in (select DeveloperId from DevelopersForRealName where RealName='" + DeveloperIdRealName + "')";
}
//开发者手机号
if (!string.IsNullOrEmpty(DeveloperIdMobile))
{
condition += " and DeveloperId in (select DeveloperId from DevelopersForMobile where Mobile='" + DeveloperIdMobile + "')";
}


            Dictionary<string, object> obj = new AdminContent(_accessor.HttpContext, SystemPublicFuction.dbtables).IndexData("ProjectVersion", Fields, "Id desc", "0", 1, 20000, condition, "", false);
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;
            foreach (Dictionary<string, object> dic in diclist)
            {
                //小程序项目
// dic["ProjectId"] = RelationClass.GetProjectsInfo(int.Parse(dic["ProjectId"].ToString()));
//所属用户
int UserId = int.Parse(function.CheckInt(dic["UserId"].ToString()));
Users userid_Users = db.Users.FirstOrDefault(m => m.Id == UserId) ?? new Users();
dic["UserIdRealName"] = userid_Users.RealName;
dic["UserIdMobile"] = userid_Users.Mobile;
dic.Remove("UserId");
//开发者
int DeveloperId = int.Parse(function.CheckInt(dic["DeveloperId"].ToString()));
Developers developerid_Developers = db.Developers.FirstOrDefault(m => m.Id == DeveloperId) ?? new Developers();
dic["DeveloperIdNickName"] = developerid_Developers.NickName;
dic["DeveloperIdRealName"] = developerid_Developers.RealName;
dic["DeveloperIdMobile"] = developerid_Developers.Mobile;
dic.Remove("DeveloperId");

            }

            Dictionary<string, object> result = new Dictionary<string, object>();
            result.Add("Status", "1");
            result.Add("Info", "Excel报表-" + DateTime.Now.ToString("yyyy-MM-ddTHH:mm:ss") + ".xlsx");
            result.Add("Obj", diclist);
            Dictionary<string, object> ReturnFields = new Dictionary<string, object>();
            
            result.Add("Fields", ReturnFields);
            AddSysLog("0", "ProjectVersion", "ExportExcel");
            return Json(result);
        }

        #endregion

    }
}
